#ifndef CAMERA_H
#define CAMERA_H

#include <stdint.h>
#include <limits>
#include "entity.cuh"
#include "common.cuh"
#include "scene.cuh"


//template <class T> class scene;

class Camera : public Entity {
  public:
    Camera(Scene *active_scene, const T fov = 1, const vect3 pos = make_vect3(0), const vect3 rot = make_vect3(0)) 
      : Entity(pos, rot, make_vect3(0)), active_scene(active_scene), fov(fov) {};
    __device__ vect3 render();
  private:
    T clip_min = .1; //will allow changing later
    T clip_max = 100;
    T fov;
    float3 viewport_size = make_float3(1,1,0); //TODO float3
    Scene *active_scene;
    
};

#endif
