#include <stdio.h>
#include "common.cuh"
#include "scene.cuh"

__device__ Render_object *Scene::raycast(struct Ray ray) {
  const int MAX_STEPS = 20; //LTERM TODO optimize
  const T INTERSECT_DIST = 0.01;
  const T MISS_DIST = 20;
  T closest_dist; 
  int dist;
  if(ray.bounces-- < 0) return nullptr; //TODO return skybox
  for(int steps = 0; steps < MAX_STEPS; steps++) {
    closest_dist = T_MAX;
    for(size_t obj_i = 0; render_objs[obj_i] != nullptr; obj_i++) {
      //LTERM TODO: maybe move this statement once you benchmark a solid testcase
      if(dist < INTERSECT_DIST) return render_objs[obj_i];
      dist = fabs(render_objs[obj_i]->distance_estimator(ray.start));
      if(dist < closest_dist) closest_dist = dist;
    }
    //LTERM TODO: maybe move these statements once you benchmark a solid testcase
    if(closest_dist > MISS_DIST) return nullptr; //TODO return skybox
    ray.start = ray.start + (ray.direction * closest_dist);
  }

}

//does not check for bounds; we'll remove this function later
__host__ void Scene::add_render_object(Render_object *object) { 
  size_t obj_i;
  for(obj_i = 0; render_objs[obj_i] != nullptr; obj_i++);
  render_objs[obj_i] = object;
}

